#ifndef _OWLPS_POSITIONING_OUTPUTCSV_HH_
#define _OWLPS_POSITIONING_OUTPUTCSV_HH_

#include "outputmedium.hh"
#include "textfilewriter.hh"

/// Writes results to a CSV file
/**
 * CSV format is:
 *   Mobile_MAC;Timestamp;Algorithm1;X;Y;Z;…;AlgorithmN;X;Y;Z
 */
class OutputCSV: public OutputMedium
{
protected:
  TextFileWriter file ;

  const std::string result_to_csv(const Result &result) ;
  const std::string results_to_csv(const ResultList &results) ;

public:
  OutputCSV(const std::string &filename):
    file(filename) {}

  void write(const Result &result) ;
  void write(const ResultList &results) ;
} ;



/* *** Operations *** */


inline void OutputCSV::write(const Result &result)
{
  file.write_text(result_to_csv(result) + '\n') ;
}


inline void OutputCSV::write(const ResultList &results)
{
  file.write_text(results_to_csv(results) + '\n') ;
}



#endif // _OWLPS_POSITIONING_OUTPUTCSV_HH_
