#include "resultlist.hh"
#include "request.hh"

using namespace std ;



/* *** Constructors *** */


ResultList::~ResultList()
{
  results.clear() ;
}



/* *** Operators *** */


const ResultList& ResultList::operator=(const ResultList &source)
{
  if (this == &source)
    return *this ;

  request = source.request ;
  results = source.results ;

  return *this ;
}


bool ResultList::operator==(const ResultList &source) const
{
  return
    request == source.request &&
    results == source.results ;
}



ostream& operator<<(ostream &os, const ResultList &r)
{
  if (r.request == NULL)
    os << "For an unknown request:\n" ;
  else
    os << "For the following request: " << *(r.request) << '\n' ;

  vector<Result>::const_iterator res ;
  for (res = r.results.begin() ; res != r.results.end() ; ++res)
    os << *res << '\n' ;

  return os ;
}
